local FRACUNIT = FRACUNIT
--local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
--local k_sneakertimer = k_sneakertimer
--local k_spinouttimer = k_spinouttimer
--local k_wipeoutslow = k_wipeoutslow
--local k_driftboost = k_driftboost
--local k_floorboost = k_floorboost
--local k_startboost = k_startboost
local k_itemamount = k_itemamount
--local k_itemtype = k_itemtype
--local k_rocketsneakertimer = k_rocketsneakertimer
--local k_hyudorotimer = k_hyudorotimer
--local k_drift = k_drift
--local k_speedboost = k_speedboost
--local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
--local k_throwdir = k_throwdir

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)


-- Yes, I am recycling Doomsday assets and code.
-- If it ain't broke, don't fix it.

freeslot(
	"MT_JUDGMENTSOUND",
	"MT_JUDGMENTFIRE",
	"SPR_DDWC",
	"S_DDAYWARNING",
	"MT_DDAYWARNING",
	"MT_DDWARNCENTER",
	"SPR_DDYL",
	"S_DDAYLASER",
	"MT_DDAYLASER",
	"S_ROCKETDED",
	"MT_VERTLROCKET",
	"S_VERTLROCKET",
	"SPR_VRKT",
	"SFX_DDNUK2",
	"SPR_XECR"
)

function A_BurstRing(actor, var1, var2)
	local radius = 3*(FixedMul((3 * (192 * FRACUNIT)) / 2, mapobjectscale) + (32 * mapobjectscale))/4
	for i = 0, 16 do
		local dust = P_SpawnMobj(actor.x, actor.y, actor.z, MT_SMOKE)
		dust.state = S_OPAQUESMOKE1
		dust.angle = (ANGLE_180/8) * i
		dust.scale = actor.scale
		dust.destscale = actor.scale*10
		dust.scalespeed = actor.scale/12
		P_InstaThrust(dust, dust.angle, FixedMul(16*FRACUNIT, actor.scale))
		
		K_SpawnKartExplosion(actor.x, actor.y, actor.z,
				radius, 32, MT_BOOSTFLAME,
				i * (ANGLE_45 / 4), true, true, actor)
				
		K_SpawnKartExplosion(actor.x, actor.y, actor.z,
				radius, 32, MT_MINEEXPLOSION,
				i * (ANGLE_45 / 4), true, false, actor)
	end
	P_SpawnMobj(actor.x, actor.y, actor.z, MT_MINEEXPLOSIONSOUND)
end

for i = 0, 12
	freeslot("SFX_NEOS"..i)
end

for i = 1, 7
	freeslot("sfx_drkfz"..i)
end

for i = 1, 12
	freeslot("S_JUDGMENTFIRE"..i)
end

states[S_DDAYWARNING] = {SPR_DDWC, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_DDAYWARNING}
states[S_DDAYLASER] = {SPR_DDYL, FF_FULLBRIGHT|FF_ANIMATE|A, 8, nil, 7, 1, S_NULL}
states[S_JUDGMENTFIRE1] = {SPR_FZBM, FF_FULLBRIGHT, 2, nil, 0, 0, S_JUDGMENTFIRE2}
states[S_JUDGMENTFIRE2] = {SPR_FZBM, FF_FULLBRIGHT|1, 2, nil, 0, 0, S_JUDGMENTFIRE3}
states[S_JUDGMENTFIRE3] = {SPR_FZBM, FF_FULLBRIGHT|2, 2, nil, 0, 0, S_JUDGMENTFIRE4}
states[S_JUDGMENTFIRE4] = {SPR_FZBM, FF_FULLBRIGHT|3, 2, nil, 0, 0, S_JUDGMENTFIRE5}
states[S_JUDGMENTFIRE5] = {SPR_FZBM, FF_FULLBRIGHT|2, 1, A_FZBoomSmoke, 0, 0, S_JUDGMENTFIRE6}
states[S_JUDGMENTFIRE6] = {SPR_FZBM, FF_FULLBRIGHT|1, 1, A_FZBoomSmoke, 0, 0, S_JUDGMENTFIRE7}
states[S_JUDGMENTFIRE7] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 1, 0, S_JUDGMENTFIRE8}
states[S_JUDGMENTFIRE8] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 2, 0, S_JUDGMENTFIRE9}
states[S_JUDGMENTFIRE9] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 3, 0, S_JUDGMENTFIRE10}
states[S_JUDGMENTFIRE10] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 2, 0, S_JUDGMENTFIRE11}
states[S_JUDGMENTFIRE11] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 1, 0, S_JUDGMENTFIRE12}
states[S_JUDGMENTFIRE12] = {SPR_NULL, 0, 1, A_FZBoomSmoke, 0, 0, S_NULL}

states[S_VERTLROCKET] = {SPR_VRKT, FF_ANIMATE|A, -1, nil, 5, 2, S_VERTLROCKET}
states[S_ROCKETDED] = {
	sprite = SPR_NULL,
	frame = A,
	action = A_BurstRing,
	tics = TICRATE,
	nextstate = S_NULL
}

mobjinfo[MT_JUDGMENTSOUND] = {
	doomednum = -1,             // doomednum
	spawnstate = S_INVISIBLE,    // spawnstate
	spawnhealth = 1,            // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_None,       // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_None,       // attacksound
	painstate = S_NULL,         // painstate
	speed = 0,              // speed
	radius = 16*FRACUNIT,    // radius
	radius = 16*FRACUNIT,    // height
	mass = 100,            // mass
	damage = 0,              // damage
	activesound = sfx_None,       // activesound
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY // flags
}

mobjinfo[MT_DDWARNCENTER] = {
	doomednum = -1,             // doomednum
	spawnstate = S_INVISIBLE,    // spawnstate
	spawnhealth = 1,            // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_None,       // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_None,       // attacksound
	painstate = S_NULL,         // painstate
	speed = 0,              // speed
	radius = 16*FRACUNIT,    // radius
	radius = 16*FRACUNIT,    // height
	mass = 100,            // mass
	damage = 0,              // damage
	activesound = sfx_None,       // activesound
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY // flags
}

mobjinfo[MT_JUDGMENTFIRE] = {           // MT_FZEROBOOM
	doomednum = -1,             // doomednum
	spawnstate = S_INVISIBLE,    // spawnstate
	spawnhealth = 1000,           // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_kc31,       // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_kc51,       // attacksound
	painstate = S_NULL,         // painstate
	speed = 0,              // speed
	radius = FRACUNIT,       // radius
	height = FRACUNIT,       // height
	dispoffset = 0,              // display offset
	mass = 0,              // mass
	damage = 0,              // damage
	activesound = sfx_None,       // activesound
	flags = MF_ENEMY|MF_SPECIAL, // flags
}

mobjinfo[MT_DDAYLASER] = {           // MT_FZEROBOOM
	doomednum = -1,             // doomednum
	spawnstate = S_DDAYLASER,    // spawnstate
	spawnhealth = 1000,           // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_kc31,       // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_kc51,       // attacksound
	painstate = S_NULL,         // painstate
	speed = 0,              // speed
	radius = 32*FRACUNIT,       // radius
	height = 512*FRACUNIT,       // height
	dispoffset = 0,              // display offset
	mass = 0,              // mass
	damage = 0,              // damage
	activesound = sfx_None,       // activesound
	flags = MF_NOBLOCKMAP|MF_DONTENCOREMAP|MF_NOCLIP, // flags
}

mobjinfo[MT_DDAYWARNING] = {
	spawnstate = S_DDAYWARNING,
	spawnhealth = 1000,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_DONTENCOREMAP|MF_NOCLIP
}


mobjinfo[MT_VERTLROCKET] = {
	doomednum = -1,             // doomednum
	spawnstate = S_VERTLROCKET,        // spawnstate
	spawnhealth = 1,              // spawnhealth
	seestate = S_NULL,         // seestate
	seesound = sfx_rlshot,     // seesound
	reactiontime = 8,              // reactiontime
	attacksound = sfx_None,       // attacksound
	painchance = 64*FRACUNIT,              // painchance
	painsound = sfx_None,       // painsound
	deathstate = S_ROCKETDED,   // deathstate
	deathsound = sfx_s3k5d,      // deathsound
	speed = 64*FRACUNIT,    // speed
	radius = 16*FRACUNIT,    // radius
	height = 32*FRACUNIT,    // height
	dispoffset = 0,              // display offset
	mass = 100,            // mass
	damage = 1,              // damage
	activesound = sfx_s3kc0s,     // activesound
	flags = MF_SHOOTABLE|MF_MISSILE|MF_DONTENCOREMAP  // flags
}

local rockets = {MT_VERTLROCKET}

for _,i in ipairs(rockets)
	addHook("MobjSpawn", function(mo)
		mo.scale = (3*mapobjectscale)/2
	end, i)
end

local eggplay
local darkFalz = false
addHook("NetVars", function(net)
	eggplay = net($)
	darkFalz = net($)
end)

-- Reimplemented FZEROBOOM because a) I like having my eyesight intact and
-- b) The horizontal momentum from vanilla boom doesn't fit well with
-- random angle stuff during DISASTER

local function DD_FirePillar(mo)
	if not (mo and mo.valid) then return end
	if not mo.extravalue2 then mo.extravalue2 = 0 end

	if not mo.extravalue1 then
		/*
		if server.ddjudgmentmode == 1 then
			local explosion = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), MT_THOK)

			explosion.state = S_JUDGMENTFIRE1
			explosion.scale = mo.scale

			--S_StartSound(mo, mo.info.seesound)
		end
		*/
		mo.extravalue1 = 1
	end

	if not S_SoundPlaying(mo, mo.info.attacksound) then
		S_StartSoundAtVolume(mo, mo.info.attacksound, 160)
	end

	if mo.extravalue2 <= 8 // Short delay
		mo.extravalue2 = $+1 // flametimer
	else // fire + smoke pillar
		if leveltime%3 == 0 then
			local fire = P_SpawnMobj(mo.x + (P_RandomRange(-32, 32)*mo.scale), mo.y + (P_RandomRange(-32, 32)*mo.scale), mo.z, MT_THOK)

			fire.sprite = SPR_FPRT
			fire.frame = FF_FULLBRIGHT|FF_TRANS30
			fire.scale = mo.scale*4
			fire.momz = P_RandomRange(2, 3)*mo.scale
			fire.scalespeed = mo.scale/12
			fire.destscale = 1
			fire.color = darkFalz and SKINCOLOR_MAROON or SKINCOLOR_CREAMSICLE
			fire.colorized = true
			fire.flags = $|MF_ENEMY|MF_SPECIAL
			fire.tics = TICRATE

			for i = 0, 1
				local smoke = P_SpawnMobj(mo.x + (P_RandomRange(-16, 16)*mo.scale), mo.y + (P_RandomRange(-16, 16)*mo.scale), mo.z, MT_SMOKE)

				mo.state = S_FZSLOWSMOKE1
				smoke.scale = mo.scale
				smoke.momz = P_RandomRange(3, 10)*mo.scale
				smoke.destscale = mo.scale*4
				smoke.scalespeed = mo.scale/24
				smoke.color = darkFalz and SKINCOLOR_MAROON or SKINCOLOR_CREAMSICLE
				smoke.colorized = true
			end
		end
	end
end
addHook("MobjThinker", DD_FirePillar, MT_JUDGMENTFIRE)

local function EGG_FireFlicker(mo)
	if not (mo and mo.valid) then return end
	
	if mo.sprite ~= SPR_FPRT then return end
	
	if (leveltime & 1) then
		mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
end
addHook("MobjThinker", EGG_FireFlicker, MT_THOK)

-- This checks for whether an object would spawn in a wall/impassable linedef
-- and ultimately attempts to move it somewhere in open space.

local function getNormalizedVectors(x, y)
    local angle = R_PointToAngle2(0, 0, x, y)
    return FixedMul(1*FRACUNIT, cos(angle)), FixedMul(1*FRACUNIT, sin(angle))
end

-- Thanks Ashnal!
local function Clamp(value, newmin ,newmax)
	return min(newmax,max(newmin,value))
end

local function DD_NearPoint(line, mo)
	local lineX, lineY = line.v2.x - line.v1.x, line.v2.y - line.v1.y
	--print("LineX, LineY: "..lineX..", "..lineY)
	local length = R_PointToDist2(line.v1.x, line.v1.y, line.v2.x, line.v2.y)

	lineX, lineY = getNormalizedVectors(lineX, lineY)
	--print("Normalized LineX, LineY: "..lineX..", "..lineY)

	local vX = mo.x - line.v1.x
	local vY = mo.y - line.v1.y
	--print("Secondary vector: "..vX..", "..vY)
	
	
	local angle = R_PointToAngle2(vX, vY, lineX, lineY)
	--print("Angle: "..angle/ANG1)

	local A = FixedSqrt(abs((FixedMul(vX, vX) + FixedMul(vY, vY))))
	local B = FixedSqrt(abs((FixedMul(lineX, lineX) + FixedMul(lineY, lineY))))
	local d = A * B * cos(angle)
	d = Clamp($, 0, length)
	
	return line.v1.x + FixedMul(lineX, d), line.v1.y + FixedMul(lineY, d)
end

local function DD_FuckWalls(spawn, x, y, z)
	local mo = P_SpawnMobj(x, y, z, spawn)
	if not (mo and mo.valid) then return end

	if not P_TryMove(mo, x, y) then
		--print("Initial move failed")
		local subsector = R_PointInSubsector(x, y)
		local sec = subsector.sector
		local radius = FixedMul(200*FRACUNIT, mapobjectscale)

		-- Bless Juggy because hoooolyyyy shit I never would've
		-- figured this out on my own.

		for i = 0, #sec.lines-1
			local newx, newy = DD_NearPoint(sec.lines[i], mo)
			
			local dist = R_PointToDist2(x, y, newx, newy)
			
			local finalX = (x + 2*dist)
			local finalY = (y + 2*dist)
			if P_CheckPosition(mo, finalX, finalY) then
				--print("New valid coordinates")
				P_SetOrigin(mo, finalX, finalY, z)
				--S_StartSound(mo, sfx_itemup)
				break
			end
		end
	end
	
	return mo
end

-- I like how Elim does the warning orbit thing around players, so let's
-- also do that for DISASTER beams!

local function cSpd(ang, spd, mo)
	if mo == nil then mo = {scale=FRACUNIT} end
	spd = FixedMul(spd, mo.scale)
	return FixedMul( cos(ang), spd ), FixedMul( sin(ang), spd )
	--returns x and y of calc
end

local function DD_Orbiter(actor)
	if not (actor and actor.valid) then return end

	if not (actor.DDorbit and actor.DDorbit.valid) then
		actor.fuse = 40
		for i = 1, 8 do
			local e = P_SpawnMobj(actor.x, actor.y, actor.z, MT_DDAYWARNING)
			e.target = actor
			e.colorized = true
			e.angmod = ANGLE_45 * i
			if i == 1 then
				actor.DDorbit = e
			end
		end
	end
end

-- This is now a 2-part hazard where the warning first spawns, then the beam
-- strike once the fuse on the warning expires. Makes driving more fair in 
-- DISASTER and puts the Emergency Code on par with EXPLOSION in terms of
-- difficulty.
local function JudgmentWarning(x, y, z, grounded)
	local subsector = R_PointInSubsector(x, y)
	local sec = subsector.sector
	local special = sec.special

	-- Don't spawn in sectors with deathpits or sky textures
	if (GetSecSpecial(special, 1) >= 6 and GetSecSpecial(special, 1) <= 8) 
	or sec.floorpic == "F_SKY" then
		return
	end

	--local actor = P_SpawnMobj(x, y, z, MT_DDWARNCENTER)
	local actor = DD_FuckWalls(MT_DDWARNCENTER, x, y, z)
	
	if (not P_IsObjectOnGround(actor))
	or z < actor.floorz then
		P_SetOrigin(actor, x, y, actor.floorz)
	end

	actor.DDfinalspawn = true
end

local function DD_WarnThinker(mo)
	if not (mo and mo.valid) then return end
	if mo.DDactive == nil then mo.DDactive = 0 end
	
	mo.DDactive = $+1
	mo.color = leveltime%7 > 3 and SKINCOLOR_RED or SKINCOLOR_BLUE
	
	if darkFalz then
		mo.color = leveltime%7 > 3 and SKINCOLOR_MAROON or SKINCOLOR_BLACK
	end

	if (mo and mo.valid) and mo.DDactive > 1 then
		if mo.target and mo.target.valid and mo.target.DDorbit then
			local t = mo.target
			local spread = abs(t.fuse - 41)
			local thisAng = leveltime*(ANG2*3)
			local x,y = cSpd(thisAng+mo.angmod, (spread*5)*FRACUNIT, t)
			P_MoveOrigin(mo, t.x+x, t.y+y, t.z)
		else
			P_RemoveMobj(mo)
			return
		end
	end
end
addHook("MobjThinker", DD_WarnThinker, MT_DDAYWARNING)

local function Judgment(x, y, z)
	--print("DED")
	local vbolt
	local hbolt
	local rbolt
	local sx
	local sy
	local an
	local radius = FixedMul(200*FRACUNIT, mapobjectscale)
	local sound = P_SpawnMobj(x, y, z, MT_JUDGMENTSOUND)
	
	/*
	if server.ddjudgmentmode == 1 then
		P_NukeEnemies(actor, actor, radius)
	elseif server.ddjudgmentmode == 2 then
		A_BurstRing(actor)
	end
	*/

	// spawn beam
	vbolt = P_SpawnMobj(x, y, z, MT_DDAYLASER)
	vbolt.scale = 4*mapobjectscale
	P_NukeEnemies(vbolt, vbolt, radius)
	--A_BurstRing(vbolt)

	vbolt.color = darkFalz and SKINCOLOR_MAROON or SKINCOLOR_CREAMSICLE
	
	local fire = P_SpawnMobj(x, y, z, MT_JUDGMENTFIRE)
	fire.fuse = 3*TICRATE
end

local function EGG_LaserVisuals(mo)
	if not (mo and mo.valid) then return end
	
	if (leveltime & 1) then
		mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
end
addHook("MobjThinker", EGG_LaserVisuals, MT_DDAYLASER)

local function DD_Strike(mo)
	if not (mo and mo.valid) then return end

	if mo.DDfinalspawn then
		DD_Orbiter(mo)
	end

	if mo.fuse == 1 then
		Judgment(mo.x, mo.y, mo.z)
	end
end
addHook("MobjThinker", DD_Strike, MT_DDWARNCENTER)

local function thunderclap(mo)
	if not mo and mo.valid then return end
	
	if mo.health
	and not mo.ddthunder
		S_StartSound(mo, sfx_s3k54)
		mo.ddthunder = true
	end
	
	if mo.ddthunder
	and not S_SoundPlaying(mo, sfx_s3k54) then
		P_KillMobj(mo)
	end
end
addHook("MobjThinker", thunderclap, MT_JUDGMENTSOUND)

local function DD_RocketDrop(x, y, z)
	local subsector = R_PointInSubsector(x, y)
	local sec = subsector.sector
	local special = sec.special

	-- Don't spawn in sectors with deathpits or sky textures
	if (GetSecSpecial(special, 1) >= 6 and GetSecSpecial(special, 1) <= 8) 
	or sec.floorpic == "F_SKY" then
		return
	end
	
	local rocket = DD_FuckWalls(MT_VERTLROCKET, x, y, z)
	rocket.color = darkFalz and SKINCOLOR_BLACK or SKINCOLOR_KETCHUP
end

local function DD_ANGDiff(mo)
	if leveltime < 236 then return end
	if not (mo and mo.valid and mo.player) then return end
	if mo.ddangdiff == nil then mo.ddangdiff = 0 end
	if mo.ddlastang == nil then mo.ddlastang = 0 end
	local p = mo.player
	
	local newmomangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	
	mo.ddthrustforce = R_PointToDist2(0, 0, mo.momx, mo.momy)
	mo.ddangdiff = newmomangle - mo.ddlastang
	mo.ddlastang = newmomangle
	
	--print(mo.ddthrustforce.."/"..mo.ddangdiff.."/"..mo.ddlastang)
end
addHook("MobjThinker", DD_ANGDiff, MT_PLAYER)

local shrinktimer = 0
local shrinkcooldown = 0

addHook("NetVars", function(net)
	shrinktimer = net($)
	shrinkcooldown = net($)
end)

-- Sound Stuff

local function NEO_EggTaunt()
	if (shrinktimer >= 5*TICRATE and shrinktimer <= 20*TICRATE)
	and shrinktimer%(P_RandomRange(TICRATE/2, 4*TICRATE)) == 0 then
		--print("TIME TO TAUNT")
		return 1
	end
	
	return 0
end

local EggIntro = {
	sfx_neos2,
	sfx_neos5,
	sfx_neos6
}

local EggOutro = {
	sfx_neos8,
	sfx_neos9,
	sfx_neos10,
	sfx_neos12
}

local function NEOS_PlaySound(table)
	if type(table) ~= "table" then return end
	
	local playsound = table[P_RandomRange(1, #table)]
	S_StartSound(nil, playsound)
end

local EggTaunt = {
	sfx_neos1,
	sfx_neos3,
	sfx_neos4,
	sfx_neos7
}

local lastEggTaunt = {
	[sfx_neos1] = {
		sfx_neos3,
		sfx_neos4,
		sfx_neos7
	},

	[sfx_neos3] = {
		sfx_neos1,
		sfx_neos4,
		sfx_neos7
	},
	
	[sfx_neos4] = {
		sfx_neos1,
		sfx_neos3,
		sfx_neos7
	},

	[sfx_neos7] = {
		sfx_neos1,
		sfx_neos3,
		sfx_neos4
	},
}

local FalzIntro = {
	sfx_drkfz3,
	sfx_drkfz4,
	sfx_drkfz6
}

local FalzOutro = {
	sfx_drkfz7
}

local FalzTaunt = {
	sfx_drkfz1,
	sfx_drkfz2,
	sfx_drkfz5,
}

local lastFalzTaunt = {
	[sfx_drkfz1] = {
		sfx_drkfz2,
		sfx_drkfz5
	},

	[sfx_drkfz2] = {
		sfx_drkfz1,
		sfx_drkfz5
	},

	[sfx_drkfz5] = {
		sfx_drkfz1,
		sfx_drkfz2
	}
}

local function useNeoShrink(p, cmd)
	server.lastEgg = 0

	if P_RandomChance(FRACUNIT/3) then
		darkFalz = true
	else
		darkFalz = false
	end
	 
	local Alarm = darkFalz and FalzIntro or EggIntro

	S_StartSound(nil, sfx_neos0)
	NEOS_PlaySound(Alarm)
	K_PlayPowerGloatSound(p.mo)

	shrinktimer = 30*TICRATE
	shrinkcooldown = 60*TICRATE
	server.shrinkowner = p

	if (hitfeed) then
		local s = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
		local icon = "K_HMSRK"
			
		HF_SendHitMessage(s, nil, icon)
	end
	p.kartstuff[k_itemamount] = $ - 1
end

local function NeoShrinkOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	local nod = newodds
	if shrinkcooldown > 0
	or pexiting
		nod = 0
	end
	return nod
end

local function DD_DisasterProc()
	if leveltime%P_RandomRange(TICRATE/2,3*TICRATE/2) == 0
		return 1
	end
	
	return 0
end

local function PlayerCount()
	local count = 0
	
	for p in players.iterate
		if p.spectator then continue end
		
		count = $ + 1
	end
	
	return count
end

local missileDrop
addHook("NetVars", function(net)
	missileDrop = net($)
end)
local function NeoShrinkHandler()
	if leveltime < 2 then return end
	
	shrinkcooldown = max($ - 1, 0)

	if not shrinktimer then return end
	
	if NEO_EggTaunt()
		if server.lastEgg then
			local soundTable = darkFalz and lastFalzTaunt or lastEggTaunt
			local soundRange = darkFalz and 2 or 3
			eggplay = soundTable[server.lastEgg][P_RandomRange(1, soundRange)]
		else
			local soundTable = darkFalz and FalzTaunt or EggTaunt
			local soundRange = darkFalz and 3 or 4
			eggplay = soundTable[P_RandomRange(1, soundRange)]
		end

		for p in players.iterate
			if p.spectator then continue end

			if not (S_SoundPlaying(p.mo, sfx_neos1)
			or S_SoundPlaying(p.mo, sfx_neos3)
			or S_SoundPlaying(p.mo, sfx_neos4)
			or S_SoundPlaying(p.mo, sfx_neos7)
			or S_SoundPlaying(p.mo, sfx_drkfz1)
			or S_SoundPlaying(p.mo, sfx_drkfz2)
			or S_SoundPlaying(p.mo, sfx_drkfz5)) then
				--print("PLAY SOUND! "..eggplay)
				S_StartSound(p.mo, eggplay, p)
				server.lastEgg = eggplay
			end
		end
	end

	if DD_DisasterProc() then
		missileDrop = P_RandomChance(2*FRACUNIT/5)

		local racers = {} -- count number of active players, re-evaluate every tick to catch leavers/spectators
		
		for p in players.iterate
			if not p.spectator then 
				--if leveltime%TICRATE == 0 then
					--print("Ceiling: "..p.mo.ceilingz)
				--end
				if (P_IsObjectOnGround(p.mo) or p.kartstuff[k_pogospring])
				and p.kartstuff[k_position] <= server.shrinkowner.kartstuff[k_position] then -- Non-pogo jumps make hazards unfun
					table.insert(racers, p)
				end
			end
		end

		local randomPlayer

		if #racers > 0 then
			randomPlayer = racers[P_RandomRange(1, #racers)]
		end

		if randomPlayer and randomPlayer.mo and randomPlayer.mo.valid then
			local ipos
			local p = randomPlayer
			local pmo = p.mo
			local sx = pmo.momx*40
			local sy = pmo.momy*40
			local sr = FixedMul(pmo.radius*3, mapobjectscale)/FRACUNIT
			local sa = pmo.angle
			if G_RaceGametype() then
				if p.speed <= FixedMul(pmo.radius * 2, mapobjectscale) then
					sx = FixedMul(pmo.radius*20, cos(sa))
					sy = FixedMul(pmo.radius*20,sin(sa))
				end
				
				if missileDrop then
					if p.kartstuff[k_drift] ~= 0 then
						local st = (9*pmo.ddthrustforce)/8
						local sd = pmo.ddangdiff
						sa = R_PointToAngle2(0, 0, pmo.momx, pmo.momy)
						local trace = P_SpawnMobj(pmo.x, pmo.y,pmo.z, MT_THOK)
						for i = 1, 40
							P_MoveOrigin(trace, trace.x + FixedMul(st, cos(sa+sd*i)), trace.y + FixedMul(st, sin(sa+sd*i)) , trace.z)
						end
						ipos = {
							x = trace.x + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, cos(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							y = trace.y + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, sin(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(pmo.ceilingz - (48*mapobjectscale),pmo.z + 896*mapobjectscale)
						}
						if trace and trace.valid then
							P_KillMobj(trace)
						end
					else
						sx = (5*$)/4
						sy = (5*$)/4
						ipos = {
							x = pmo.x + sx + (FixedMul(FixedMul(P_RandomRange(0, 127)*FRACUNIT, mapobjectscale), cos(sa + (P_RandomRange(-90, 90)*ANG1)))), -- Item spawn has a random horizontal offset.
							y = pmo.y + sy + (FixedMul(FixedMul(P_RandomRange(0, 127)*FRACUNIT, mapobjectscale), sin(sa + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(pmo.ceilingz - (pmo.height*2),pmo.z + 896*mapobjectscale)
						}
					end
				else
					if p.kartstuff[k_drift] ~= 0 then
						local st = pmo.ddthrustforce
						local sd = pmo.ddangdiff
						sa = R_PointToAngle2(0, 0, pmo.momx, pmo.momy)
						local trace = P_SpawnMobj(pmo.x, pmo.y,pmo.z, MT_THOK)
						for i = 1, 40
							P_MoveOrigin(trace, trace.x + FixedMul(st, cos(sa+sd*i)), trace.y + FixedMul(st, sin(sa+sd*i)) , trace.z)
						end
						ipos = {
							x = trace.x + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, cos(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							y = trace.y + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, sin(sa + (sd*40) + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(trace.z + trace.height*2, trace.ceilingz)
						}
						if trace and trace.valid then
							P_KillMobj(trace)
						end
					else
						ipos = {
							x = pmo.x + sx + (FixedMul(P_RandomRange(0, 127)*FRACUNIT, cos(sa + (P_RandomRange(-90, 90)*ANG1)))),
							y = pmo.y + sy + (FixedMul(FixedMul(P_RandomRange(0, 127)*FRACUNIT, mapobjectscale), sin(sa + (P_RandomRange(-90, 90)*ANG1)))),
							z = min(pmo.z + pmo.height*2, pmo.ceilingz)
						}
					end
				end
			else
				if missileDrop then
					ipos = {x = pmo.x + P_SignedRandom()*P_RandomRange(8,16)*FRACUNIT, -- Item spawn has a random horizontal offset.
										y = pmo.y + P_SignedRandom()*P_RandomRange(8,16)*FRACUNIT,
										z = min(pmo.ceilingz - (48*mapobjectscale),pmo.z + 320*mapobjectscale)}
				else
					ipos = {
						x = pmo.x + P_SignedRandom()*P_RandomRange(4,8)*FRACUNIT, -- Item spawn has a random horizontal offset.
						y = pmo.y + P_SignedRandom()*P_RandomRange(4,8)*FRACUNIT,
						z = min(pmo.z +pmo.height*2, pmo.ceilingz)
					}
				end
			end
			if missileDrop then
				DD_RocketDrop(ipos.x, ipos.y, ipos.z)
			else
				JudgmentWarning(ipos.x, ipos.y, ipos.z)
			end
		end
	end
	
	if shrinktimer == 1 then
		local Exit = darkFalz and FalzOutro or EggOutro
		NEOS_PlaySound(Exit)
		server.lastEgg = 0
	end

	shrinktimer = max($ - 1, 0)
end
addHook("ThinkFrame", NeoShrinkHandler)

addHook("MapLoad", function()
	server.shrinkowner = -1
	shrinktimer = 0
	shrinkcooldown = 0
	server.lastEgg = 0
end)

local function NeoShrinkThinker(mo)
	if not (mo and mo.valid and mo.player) then return end
	
	local p = mo.player
	
	p.neoshrinkbuffer = $ or 0
	if p.kartstuff[k_growshrinktimer] < 0 then
		mo.destscale = (3*mapobjectscale)/4
	end
	
	p.neoshrinkbuffer = max($-1, 0)
end
addHook("MobjThinker", NeoShrinkThinker, MT_PLAYER)

local function DD_Bypass(p, i, s)
	if not (p.mo and p.mo.valid) then return end
	if not (i and i.valid) then return end
	if not (s and s.valid) then return end

	if (i.type == MT_DDAYLASER
	or i.type == MT_JUDGMENTFIRE
	or i.type == MT_VERTLROCKET) then
		return true
	end

	if (i.type == MT_MINEEXPLOSION
	and (s.type == MT_VERTLROCKET or s.type == MT_DDAYLASER)) then
		if not p.neoshrinkbuffer then
			return true
		end
	end
end
addHook("ShouldSpin", DD_Bypass)
addHook("ShouldExplode", DD_Bypass)

local function DD_ShrinkBeam(p, i, s)
	if not (p.mo and p.mo.valid) then return end
	if not (i and i.valid) then return end
	if not (s and s.valid) then return end

	if (i.type == MT_DDAYLASER
	or i.type == MT_JUDGMENTFIRE
	or i.type == MT_VERTLROCKET) then
		if server.shrinkowner == p then
			K_DoSneaker(p, 0)
		else
			local noHugeQuest = (HugeQuest and p.hugequest.huge == 0) or (not HugeQuest)
			if p.kartstuff[k_growshrinktimer] <= 0
			and noHugeQuest then
				if not p.kartstuff[k_growshrinktimer] then
					S_StartSound(p.mo, sfx_kc46)
				end

				p.kartstuff[k_growshrinktimer] = $ - 3*TICRATE
			elseif p.hugequest and p.hugequest.huge > 1 then
				p.hugequest.huge= max($ - 3*TICRATE, 1)
			end
		end

		if (i.type == MT_MINEEXPLOSION and (s.type == MT_VERTLROCKET or s.type == MT_DDAYLASER)) then
			p.neoshrinkbuffer = 3*TICRATE/4
		end
		
		return true
	end

	if (i.type == MT_MINEEXPLOSION and (s.type == MT_VERTLROCKET or s.type == MT_DDAYLASER)) then
		if not p.neoshrinkbuffer then
			if server.shrinkowner == p then
				K_DoSneaker(p, 0)
			else
				local noHugeQuest = (HugeQuest and p.hugequest.huge == 0) or (not HugeQuest)
				if p.kartstuff[k_growshrinktimer] <= 0
				and noHugeQuest then
					S_StartSound(p.mo, sfx_kc46)
					p.kartstuff[k_growshrinktimer] = $ - 3*TICRATE
				elseif p.hugequest and p.hugequest.huge > 1 then
					p.hugequest.huge= max($ - 3*TICRATE, 1)
				end
			end
			p.neoshrinkbuffer = 3*TICRATE/4
		end
		return true
	end
end
addHook("PlayerSpin", DD_ShrinkBeam)
addHook("PlayerExplode", DD_ShrinkBeam)

local function EC_Bypass(p, i, s)
	if not (p.mo and p.mo.valid) then return end
	if not (i and i.valid) then return end
	if not (s and s.valid) then return end
	if (i.type == MT_MINEEXPLOSION
	and (s.type == MT_VERTLROCKET or s.type == MT_DDAYLASER))
	and p.neoshrinkbuffer then
		return false
	end
end
addHook("ShouldSpin", EC_Bypass)
addHook("ShouldExplode", EC_Bypass)

if xItemLib then
	xItemLib.func.setGlobalOddsForItem(xItemLib.xItemNamespaces["KITEM_SHRINK"],
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0})

	xItemLib.func.addItem{
	"XITEM_EGGCARRIER", //Namespace
	"Egg Carrier", //Friendly Name
	{7, "K_ITECR1", "K_ITECR2"}, //HUD Graphic
	{7, "K_ISECR1", "K_ISECR2"}, //HUD Small Graphic
	XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_UNIQUE, //Flags
	{0, 0, 0, 0, 0, 0, 0, 2, 1, 0}, //Race Odds
	{1, 2}, //Battle Odds
	nil, //Get Item Function
	useNeoShrink, //Use Item Function
	false, //HUD Item Function
	NeoShrinkOdds, //Itemodds overrides
	nil, //Result Item Function
	{7, {SPR_XECR, A}, {SPR_XECR, B}}, //Dropped Item Frames
	true, //Show in the item roulette
	nil,
	nil}
end